if (!("finalizeConstruction" in ViewPU.prototype)) {
    Reflect.set(ViewPU.prototype, "finalizeConstruction", () => { });
}
interface Index_Params {
    message?: string;
}
import type common from "@ohos:app.ability.common";
import type Want from "@ohos:app.ability.Want";
import hilog from "@ohos:hilog";
import type { BusinessError } from "@ohos:base";
const DOMAIN_NUMBER: number = 0xFF00;
const TAG: string = '[Page_Interactive04Index]';
class Index extends ViewPU {
    constructor(parent, params, __localStorage, elmtId = -1, paramsLambda = undefined, extraInfo) {
        super(parent, __localStorage, elmtId, extraInfo);
        if (typeof paramsLambda === "function") {
            this.paramsGenerator_ = paramsLambda;
        }
        this.__message = new ObservedPropertySimplePU('Hello World', this, "message");
        this.setInitiallyProvidedValue(params);
        this.finalizeConstruction();
    }
    setInitiallyProvidedValue(params: Index_Params) {
        if (params.message !== undefined) {
            this.message = params.message;
        }
    }
    updateStateVars(params: Index_Params) {
    }
    purgeVariableDependenciesOnElmtId(rmElmtId) {
        this.__message.purgeDependencyOnElmtId(rmElmtId);
    }
    aboutToBeDeleted() {
        this.__message.aboutToBeDeleted();
        SubscriberManager.Get().delete(this.id__());
        this.aboutToBeDeletedInternal();
    }
    private __message: ObservedPropertySimplePU<string>;
    get message() {
        return this.__message.get();
    }
    set message(newValue: string) {
        this.__message.set(newValue);
    }
    initialRender() {
        this.observeComponentCreation2((elmtId, isInitialRender) => {
            Row.create();
            Row.height('100%');
        }, Row);
        this.observeComponentCreation2((elmtId, isInitialRender) => {
            Column.create({ space: 10 });
            Column.width('100%');
        }, Column);
        this.observeComponentCreation2((elmtId, isInitialRender) => {
            Text.create('UIAbility Components Interactive04');
        }, Text);
        Text.pop();
        this.observeComponentCreation2((elmtId, isInitialRender) => {
            Button.createWithLabel("调用方UIAbility指定启动页面");
            Button.alignRules({
                center: { anchor: '__container__', align: VerticalAlign.Center },
                middle: { anchor: '__container__', align: HorizontalAlign.Center }
            });
            Button.onClick(() => {
                let context: common.UIAbilityContext = getContext(this) as common.UIAbilityContext;
                let want: Want = {
                    deviceId: '',
                    bundleName: 'com.example.uiabilitycomponentsinteractive04',
                    moduleName: 'entry',
                    abilityName: 'FuncAbility',
                    parameters: {
                        router: 'funcA'
                    }
                };
                context.startAbility(want).then(() => {
                    hilog.info(DOMAIN_NUMBER, TAG, 'Succeeded in starting FuncAbility.');
                }).catch((err: BusinessError) => {
                    hilog.error(DOMAIN_NUMBER, TAG, `Failed to start FuncAbility. Code is ${err.code}, message is ${err.message}`);
                });
            });
        }, Button);
        Button.pop();
        this.observeComponentCreation2((elmtId, isInitialRender) => {
            Button.createWithLabel("启动短信应用的UIAbility");
            Button.alignRules({
                center: { anchor: '__container__', align: VerticalAlign.Center },
                middle: { anchor: '__container__', align: HorizontalAlign.Center }
            });
            Button.onClick(() => {
                let context: common.UIAbilityContext = getContext(this) as common.UIAbilityContext;
                let want: Want = {
                    deviceId: '',
                    // uncomment line below if wish to implicitly query only in the specific bundle.
                    bundleName: 'com.example.uiabilitycomponentsinteractive041',
                    action: 'ohos.want.action.viewData',
                    // entities can be omitted.
                    entities: ['entity.system.default'],
                    parameters: {
                        router: 'funcA'
                    }
                };
                context.startAbility(want).then(() => {
                    hilog.info(DOMAIN_NUMBER, TAG, 'Succeeded in starting FuncAbility.');
                }).catch((err: BusinessError) => {
                    hilog.error(DOMAIN_NUMBER, TAG, `Failed to start FuncAbility. Code is ${err.code}, message is ${err.message}`);
                });
            });
        }, Button);
        Button.pop();
        Column.pop();
        Row.pop();
    }
    rerender() {
        this.updateDirtyElements();
    }
    static getEntryName(): string {
        return "Index";
    }
}
registerNamedRoute(() => new Index(undefined, {}), "", { bundleName: "com.example.uiabilitycomponentsinteractive04", moduleName: "entry", pagePath: "pages/Index", pageFullPath: "entry/src/main/ets/pages/Index", integratedHsp: "false" });
